# Class VulkanCommandBufferSubmitInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanCommandBufferSubmitInfo

All Implemented Interfaces:
  `VulkanCommandBufferSubmitInfoType`

public final class VulkanCommandBufferSubmitInfo extends Object implements VulkanCommandBufferSubmitInfoType
The type of Vulkan command buffer submission information.

See Also:
  - "VkCommandBufferSubmitInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanCommandBufferSubmitInfo.Builder`
  Builds instances of type `VulkanCommandBufferSubmitInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanCommandBufferSubmitInfo.Builder`
  `builder()`
  Creates a builder for `VulkanCommandBufferSubmitInfo`.
  `VulkanCommandBufferType`
  `commandBuffer()`
  `static VulkanCommandBufferSubmitInfo`
  `copyOf(VulkanCommandBufferSubmitInfoType instance)`
  Creates an immutable copy of a `VulkanCommandBufferSubmitInfoType` value.
  `long`
  `deviceMask()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanCommandBufferSubmitInfo` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `commandBuffer`, `deviceMask`.
  `String`
  `toString()`
  Prints the immutable value `VulkanCommandBufferSubmitInfo` with attribute values.
  `final VulkanCommandBufferSubmitInfo`
  `withCommandBuffer(VulkanCommandBufferType value)`
  Copy the current immutable object by setting a value for the `commandBuffer` attribute.
  `final VulkanCommandBufferSubmitInfo`
  `withDeviceMask(long value)`
  Copy the current immutable object by setting a value for the `deviceMask` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### commandBuffer

    public VulkanCommandBufferType commandBuffer()
    Specified by:
      `commandBuffer` in interface `VulkanCommandBufferSubmitInfoType`
    Returns:
      The command buffer

  - ### deviceMask

    public long deviceMask()
    Specified by:
      `deviceMask` in interface `VulkanCommandBufferSubmitInfoType`
    Returns:
      A bitmask indicating which devices in a device group execute the command buffer

  - ### withCommandBuffer

    public final VulkanCommandBufferSubmitInfo withCommandBuffer(VulkanCommandBufferType value)
    Copy the current immutable object by setting a value for the `commandBuffer` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for commandBuffer
    Returns:
      A modified copy or the `this` object

  - ### withDeviceMask

    public final VulkanCommandBufferSubmitInfo withDeviceMask(long value)
    Copy the current immutable object by setting a value for the `deviceMask` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for deviceMask
    Returns:
      A modified copy or the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanCommandBufferSubmitInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `commandBuffer`, `deviceMask`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanCommandBufferSubmitInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanCommandBufferSubmitInfo copyOf(VulkanCommandBufferSubmitInfoType instance)
    Creates an immutable copy of a `VulkanCommandBufferSubmitInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanCommandBufferSubmitInfo instance

  - ### builder

    public static VulkanCommandBufferSubmitInfo.Builder builder()
    Creates a builder for `VulkanCommandBufferSubmitInfo`.

        VulkanCommandBufferSubmitInfo.builder()
           .setCommandBuffer(com.io7m.jcoronado.api.VulkanCommandBufferType) // required commandBuffer
           .setDeviceMask(long) // optional deviceMask
           .build();

    Returns:
      A new VulkanCommandBufferSubmitInfo builder